/* This file is Copyright 2000 Level Control Systems.  See the included LICENSE.txt file for details. */

//! author="Jeremy Friesner"

#ifndef NULL_DATA_IO
#define NULL_DATA_IO

#include "dataio/PortableDataIO.h"

//: Data I/O equivalent to /dev/null.  All written bytes are dropped, no read bytes are ever returned. 
class NullDataIO : public PortableDataIO
{
public:
   NullDataIO() {NoteAllocated(this, "NullDataIO");}
   virtual ~NullDataIO() {NoteDeleted(this, "NullDataIO");}

   // No-op method, always returns zero.
   virtual ssize_t Read(void * buffer, size_t size)  {return 0;}

   // No-op method, always returns (size).
   virtual ssize_t Write(const void * buffer, size_t size) {return size;}

   // No-op method
   virtual void FlushOutput() {/* empty */}
};

#endif
